;+
; MPDM Zadanie 2.2 - Korelacja nasonecznienia ze strumieniem ciepa utajonego, argumenty:
; - dugo okresu dla ktrego wyliczana jest korelacja [30 min]
; - pozycja pocztku okresu dla ktrego wyliczana jest korelacja [30 min]
;-
pro zad2_2, count, offset
  
  ; tworzenie obiektw reprezentujcych pliki netCDF
  nc_flux = obj_new("netcdf", "flux.nc")
  nc_meteo = obj_new("netcdf", "meteo_niederoeblarn.nc")

  ; pobranie z pliku serii czasowej wartoci str. ciepa utajonego (rozdz. 30 min.)
  h20_flux_y = nc_flux->var_get("flux_latent_webb_latent")
  h20_flux_x = nc_flux->var_get("Time")

  ; pobranie z pliku serii czasowej wartoci strumienia prom. son. (rozdz 10 min.)
  rad_flux_y = nc_meteo->var_get("RAD")
  rad_flux_x = nc_meteo->var_get("Time")

  ; zamykanie plikw (zniszczenie obiektw -- destruktory zamykaj pliki)
  obj_destroy, nc_flux
  obj_destroy, nc_meteo

  ; ustalenie najmniejszego wsplnego czasu pocztkowego
  time_start = max([h20_flux_x[0L], h20_flux_y[0L]])
  idx_start_rad = where(rad_flux_x eq time_start)
  idx_start_h20 = where(h20_flux_x eq time_start)

  ; wycicie kawakw tablic pomidzy offset, a offset + count
  h20_flux_y = h20_flux_y[idx_start_h20 + offset : idx_start_h20 + offset + count - 1]
  rad_flux_y = rad_flux_y[idx_start_rad + 3 * offset : idx_start_rad + 3 * (count + offset) - 1]

  ; interpolacja do rozdz. 30 min.
  rad_flux_y = interpolate(rad_flux_y, $
    dindgen(n_elements(h20_flux_y)) * n_elements(rad_flux_y) / n_elements(h20_flux_y) $
  )

  ; podgld co si dzieje i wynik korelacji
  !P.MULTI = [0,2,2]
  plot, h20_flux_y 
  plot, h20_flux_y, rad_flux_y, /psym
  plot, rad_flux_y 
  print, correlate(h20_flux_y, rad_flux_y)

end
